/* global BDF,$$,ID,SqlExport,CodeMirror */

SqlExport.Form = {};

SqlExport.Form.load = function (sqlExportName) {
    var sqlExport = SqlExport.getSqlExport(sqlExportName);
    if (!sqlExport) {
        return;
    }
    var isInStock = false;
    var formId = BDF.generateId();
    $$("layout_main").html(BDF.render("sqlexport:form", {
        action: BDF.URL + "exportation",
        formId: formId,
        sqlExportName: sqlExport.name,
        title: sqlExport.title,
        labelArray: BDF.toLabelArray(sqlExport.labelMap),
        labelsLocKey: "_ title.exportation.sqlexportlabels",
        currentTableExportName : sqlExport.tableExportName,
        tableExportArray: SqlExport.tableExportArray,
        customClassName: sqlExport.sqlExportClassName,
        path: sqlExport.path,
        url: sqlExport.url,
        postCommand: sqlExport.postCommand,
        params: _paramsToString(),
        queryXml: sqlExport.query.ficheXml + sqlExport.query.motcleXml,
        targetName: sqlExport.targetName,
        targetPath: sqlExport.targetPath,
        fileName: sqlExport.fileName,
        availableTargetArray: BDF.pathConfiguration.targetArray,
        attributes: BDF.attrMapToString(sqlExport.attrMap),
        attributesLocKey: "_ title.exportation.sqlexportattributes",
        commandKey: "EXP-43",
        commandUrl: BDF.getCommandUrl("EXP-43")
    }));
    BDF.Deploy.init($$("layout_main"));
    $$(formId, "button_stock").click(function () {
        BDF.Pane.moveMainToStock();
    });
    $$(formId).ajaxForm({
        beforeSerialize: function ($form, options) {
            if (isInStock) {
                return false;
            } else {
                queryxmlCodeMirror.save();
                attributesCodeMirror.save();
                return true;
            }
        },
        dataType: "json",
        success: function (data, textStatus, jqXHR, $form) {
            BDF.Pane.setChange(false);
            _saveCallback(data);
        }
    });
    var queryxmlCodeMirror = BDF.toCodeMirror(ID(formId, "queryxml"), {
        lineWrapping: false,
        lineNumbers: false,
        indentUnit: 4,
        theme: 'bdf',
        mode: "xml"
    });
    queryxmlCodeMirror.on("change", function () {
        BDF.Pane.setChange(true);
    });
    var attributesCodeMirror = BDF.toCodeMirror(ID(formId, "attributes"), {
        lineWrapping: false,
        lineNumbers: false,
        indentUnit: 4,
        theme: 'bdf',
        mode: "attributes"
    });
    attributesCodeMirror.on("change", function () {
        BDF.Pane.setChange(true);
    });
    $$(formId).data("stockHandler", _stockHandler);
    BDF.Pane.checkState();
    

    function _saveCallback(data) {
        BDF.showCommandMessage(data.commandMessage);
        if (data.commandMessage.type === "done") {
            BDF.updateDefaultValues($$(formId));
            let newSqlExport = SqlExport.updateSqlExport(data.sqlExport);
            BDF.$($$(formId), {role: "metadata-title"}).html(newSqlExport.title);
        }
    }
    
    function _paramsToString() {
        var params = "";
        for(var i = 0, len =  sqlExport.paramArray.length ; i < len; i++) {
            var param = sqlExport.paramArray[i];
            if (i > 0) {
                params += "\n";
            }
            params += param.name + "=" + param.value;
        }
        return params;
    }
    
    function _stockHandler(stock) {
        isInStock = stock;
        queryxmlCodeMirror.setOption("readOnly", stock);
        attributesCodeMirror.setOption("readOnly", stock);
        BDF.Pane.setReadOnly($$(formId), stock);
    }
    
};